<template>
  <router-link :to="route" class="ml-2">
    <div class="container-button-nav" :style="{ width: width }">
      <!-- FORWARD -->
      <button
        class="flex items-center justify-center animate text-lg w-full py-3"
        @mouseover="hoverIn()"
        @mouseout="hoverOut()"
        @mousedown="clickDown()"
        @mouseup="clickUp()"
        :style="{
          border: border,
          borderColor: borderColor,
          color: color,
          borderRadius: borderRadius,
          zIndex: '100',
          backgroundColor: bgColorForward,
          position: 'absolute',
          top: topPosition,
          left: leftPosition
        }"
      >
        <font-awesome-icon
          :icon="icon"
          :class="`h-5 w-5 text-${color}-400 group-hover:text-${color}-300 mx-2`"
        />{{ text }}
      </button>

      <!-- BACKWARD -->
      <div
        class="button-backward w-full lg:py-3 md:py-1 h-full"
        :style="{
          width,
          height,
          color: color,
          backgroundColor: bgColorBack,
          borderRadius: borderRadius
        }"
      ></div>
    </div>
  </router-link>
</template>

<script>
/**
 * Button for navigation bar or other place.
 * You can custom it with props:
 * @values [route, isAnimateClick, width, height, bgColorFront, bgColorBack, border, borderRadius, borderColor, icon, text, textColor, hoverColor, hoverBgColor]
 */
export default {
  name: "Button",
  props: {
    route: String,
    isAnimateClick: {
      default: true,
      type: Boolean
    },
    width: {
      default: "150px",
      type: String
    },
    height: {
      default: "50px",
      type: String
    },
    bgColorFront: {
      default: "white",
      type: String
    },
    bgColorBack: {
      default: null,
      type: String
    },
    borderRadius: {
      default: "2em",
      type: String
    },
    border: {
      default: "1px solid",
      type: String
    },
    borderColor: {
      default: "#2B4FA2",
      type: String
    },
    icon: {
      default: null,
      svg: String
    },
    text: {
      default: "Inscription",
      type: String
    },
    textColor: {
      default: "white",
      type: String
    },
    hoverColor: {
      default: null,
      type: String
    },
    hoverBgColor: {
      default: "white",
      type: String
    }
  },
  data() {
    return {
      color: this.textColor,
      bgColorForward: this.bgColorFront,
      topPosition: "",
      leftPosition: ""
    }
  },
  methods: {
    hoverOut() {
      this.color = this.textColor
      this.bgColorForward = this.bgColorFront
    },
    hoverIn() {
      this.color = this.hoverColor
      this.bgColorForward = this.hoverBgColor
    },
    clickDown() {
      if (this.isAnimateClick) {
        this.topPosition = "0.3em"
        this.leftPosition = "-0.25em"
      }
    },
    clickUp() {
      if (this.isAnimateClick) {
        this.topPosition = ""
        this.leftPosition = ""
      }
    }
  }
}
</script>

<style scoped>
.container-button-nav {
  position: relative;
  margin: 2em;
}

.animate {
  transition: color 0.5s, background-color 0.5s;
}

.button-backward {
  position: relative;
  top: 0.5em;
  left: -0.3em;
}
</style>
